UNIT TextUI;


INTERFACE
USES
  Globals;

FUNCTION GetCmd : CmdType;


IMPLEMENTATION
USES
  Crt,
  Utils,
  Opening;


FUNCTION GetCmd : CmdType;
CONST
  FileChar = ['A'..'H'];
  RankChar = ['1'..'8'];
VAR
  InputStr : Str4;
  Code     : Int16;
BEGIN
  GetCmd := NoCmd;    {-- default value }
  Window(1, 1, 80, 25);

  {-- write input prompt }
  GoToXY(49, 13);
  Write('Move:');

  ClrEol;
  GoToXY(55, 13);
  Readln(InputStr);

  InputStr[1] := UpCase(InputStr[1]);
  IF Length(InputStr) > 2 THEN
    InputStr[3] := UpCase(InputStr[3]);

  IF Length(InputStr) = 4 THEN  {-- normal move }
    BEGIN
      IF (InputStr[1] IN FileChar) AND (InputStr[2] IN RankChar) AND
         (InputStr[3] IN FileChar) AND (InputStr[4] IN RankChar) THEN
        BEGIN
            Moves[MoveNmbr].MoveStr := InputStr;

          {-- save opening moves for library lookup }
          OpeningStr := OpeningStr + InputStr;
          GetCmd := MoveCmd;
        END
      ELSE
        ErrorMsg('Bad Input !');
    END;   {-- if }

  IF InputStr[1] IN ['T', 'X'] THEN
    BEGIN
      IF InputStr[1] = 'T' THEN    {-- set move time command }
        BEGIN
          Val(Copy(InputStr, 2, 3), MoveTime, Code);
          FixedDepth := 255;
        END;
      IF (InputStr[1] = 'X') THEN    {-- set fixed depth search }
        BEGIN
          Val(Copy(InputStr, 2, 2), FixedDepth, Code);
          IF FixedDepth < 4 THEN
            FixedDepth := 4;
          MoveTime := 9999;           {-- but max of 3 minutes }
        END;
    END;

    {-- decode command....single char commands }
    IF Length(InputStr) = 1 THEN
      CASE InputStr[1] OF
        'N' : GetCmd := NewGameCmd;
        'B' : GetCmd := BackCmd;
        'Q' : GetCmd := QuitCmd;
        'P' : GetCmd := PlayCmd;
        'S' : GetCmd := SetUpCmd;
        'W' : GetCmd := WriteCmd;
        'R' : GetCmd := ReadCmd;
        'D' : GetCmd := DebugCmd;
        'E' : GetCmd := EvalCmd;
      END;
END;



BEGIN
END.
