UNIT Init;

INTERFACE



PROCEDURE InitGame;

{----------------------------------------------------------------------------}
IMPLEMENTATION
USES
  Crt,
  Globals,
  Zorbist,
  TT,
  Opening;


PROCEDURE InitBoard;
VAR
  Sq,
  i  : Byte;
BEGIN
  WITH Data[Ply] DO
    BEGIN
      FillChar(Board, SizeOf(Board), 0);

      {-- place the pieces in their start position }
      {-- first white }
      Board[0] := Wrook;
      Board[1] := Wknight;
      Board[2] := Wbishop;
      Board[3] := Wqueen;
      Board[4] := Wking;
      Board[5] := Wbishop;
      Board[6] := Wknight;
      Board[7] := Wrook;

      FOR Sq := $10 TO $17 DO
        Board[Sq] := Wpawn;

      {-- next Black }
      Board[$70] := Brook;
      Board[$71] := Bknight;
      Board[$72] := Bbishop;
      Board[$73] := Bqueen;
      Board[$74] := Bking;
      Board[$75] := Bbishop;
      Board[$76] := Bknight;
      Board[$77] := Brook;

      FOR Sq := $60 TO $67 DO
        Board[Sq] := Bpawn;

      {-- now the piece lists }
      FOR i := 0 TO 7 DO
        BEGIN
          W_Pawns[i] := $10 + i;
          B_Pawns[i] := $60 + i;
        END;

      W_Rook[0]   :=   0;
      W_Rook[1]   :=   7;
      B_Rook[0]   := $70;
      B_Rook[1]   := $77;

      W_Knight[0] :=   1;
      W_Knight[1] :=   6;
      B_Knight[0] := $71;
      B_Knight[1] := $76;

      W_Bishop[0] :=   2;
      W_Bishop[1] :=   5;
      B_Bishop[0] := $72;
      B_Bishop[1] := $75;

      W_Queen[0] :=   3;
      W_Queen[1] := OffBoard;
      B_Queen[0] := $73;
      B_Queen[1] := OffBoard;

      W_King   := 4;
      B_King   := $74;

      {-- if the king or rook moves then it cant castle }
      WcanCastShort := True;
      WcanCastLong  := True;
      BcanCastShort := True;
      BcanCastLong  := True;

      ZorbistKey    := CalcBrdKey;
      WhtPwnHashKey := CalcWhtPwnBrdKey;
      BlaPwnHashKey := CalcBlaPwnBrdKey;

      EnpasauntSq := OffBoard;
    END;  {-- with }
END;


PROCEDURE InitData;
BEGIN
  FillChar(Moves, SizeOf(Moves), 0);
  MoveNmbr := 1;

  FillChar(Data, SizeOf(Data), 0);
  Ply := 0;

  FillChar(GameHistoryKeys, SizeOf(GameHistoryKeys), 0);
  GameHistoryIndex := 0;
  FiftyMoveCnt     := 0;

  FillChar(KillerMoves, SizeOf(KillerMoves), 0);

  HumansMove    := True;
  ComputerPlays := BlackPieces;
  Wtm           := True;

  InitZorbistBoard;
END;


PROCEDURE InitGame;
BEGIN
  ClrScr;
  InitData;
  InitBoard;
  InitTTs;
  InitOpeningLib;
END;



BEGIN
END.
